/* not right */



/* mpn_mulhighhalf_kara -- Karatsuba high half multiply.

   Copyright 2002, 2007 Kevin Ryde

   This file is part of MPM.

   MPM is free software; you can redistribute it and/or modify it under the
   terms of the GNU General Public License as published by the Free Software
   Foundation; either version 2, or (at your option) any later version.

   MPM is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
   details.

   You should have received a copy of the GNU General Public License along
   with MPM; see the file COPYING.  If not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
   USA.  */

#include "gmp.h"
#include "gmp-impl.h"
#include "longlong.h"
#include "mpm.h"
#include "mpm-impl.h"



extern mp_size_t  mpn_mulhighhalf_table[];

void
mpn_mulhighhalf_kara (mp_ptr wp, mp_srcptr xp, mp_srcptr yp, mp_size_t size)
{
  mp_ptr     tp, wcp;
  mp_size_t  ksize, csize;

  ASSERT (size >= 4);
  ASSERT (! MPN_OVERLAP_P (wp, 2*size, xp, size));
  ASSERT (! MPN_OVERLAP_P (wp, 2*size, yp, size));

  //csize = mpn_mulhighhalf_table[size];
  csize = 5*size / 16;
  ksize = size - csize;

  mpn_mul_n (wp, xp, yp, ksize);

  tp = wp + size;
  wcp = wp + ksize;

  mpn_mulhighhalf_n (tp, xp + ksize, yp, csize);
  mpn_add_n (wcp, wcp, tp, csize);

  mpn_mulhighhalf_n (tp, xp, yp + ksize, csize);
  mpn_add_n (wcp, wcp, tp, csize);
}
